unit MainUnit;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ComCtrls, StdCtrls, Buttons, Spin, MessCARUnit, Mask, ConfigUnit;

type
  TMain = class(TForm)
    Label1: TLabel;
    Mode: TPageControl;
    DateFixe: TTabSheet;
    CompteARebours: TTabSheet;
    Label2: TLabel;
    CARJours: TSpinEdit;
    CARHeures: TSpinEdit;
    CARMin: TSpinEdit;
    CARSec: TSpinEdit;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    DemarrerRebours: TBitBtn;
    ConfigurationMessageCAR: TBitBtn;
    Label7: TLabel;
    DemarrerFixe: TBitBtn;
    ConfigurationMessageFixe: TBitBtn;
    Label8: TLabel;
    Label9: TLabel;
    FixeDate: TMaskEdit;
    FixeTime: TMaskEdit;
    procedure FormCreate(Sender: TObject);
    procedure DemarrerClick(Sender: TObject);
    procedure ConfigurationClick(Sender: TObject);
  private
    { Dclarations prives }
  public
    OldLeft: integer;
    procedure CallMainShow(Sender: TObject);
    procedure CallCARDone(Sender: TObject);
  end;

var
  Main: TMain;

implementation

{$R *.dfm}

procedure ShutDown;
var sTokenIn,sTokenOut : TTOKENPRIVILEGES ;
    dwLen : DWORD ;
    hCurrentProcess,hToken : THANDLE ;
    Luid1 : TLargeInteger ;  // LUID ;
begin
  // Handle du process en cours
  hCurrentProcess := GetCurrentProcess ;
  OpenProcessToken (hCurrentProcess,TOKEN_ADJUST_PRIVILEGES or TOKEN_QUERY, hToken);
  // valeur du privilege SHUTDOWN
  LookupPrivilegeValue(nil,'SeShutdownPrivilege',Luid1) ;
  sTokenIn.PrivilegeCount := 1;
  sTokenIn.Privileges[0].Luid := Luid1;
  sTokenIn.Privileges[0].Attributes := SE_PRIVILEGE_ENABLED;
  // Ajustement du privilege avec les nouvelles valeurs
  AdjustTokenPrivileges ( hToken, FALSE, sTokenIn,sizeof(TTOKENPRIVILEGES),sTokenOut, dwLen);
  CloseHandle (hToken);
  if Config.UseForce.Checked then
    ExitWindowsEx(EWX_SHUTDOWN {or EWX_FORCE}, 0) //Sortie NT
  else
    ExitWindowsEx(EWX_SHUTDOWN or EWX_FORCE, 0);
end;

procedure TMain.CallCARDone(Sender: TObject);
begin
  ShutDown;
end;

procedure TMain.CallMainShow(Sender: TObject);
begin
  Left := OldLeft;
  Show;
end;

procedure TMain.FormCreate(Sender: TObject);
begin
  DateSeparator := '/';
  TimeSeparator := ':';
  LongDateFormat := 'dd/mm/yyyy';
  ShortDateFormat := 'dd/mm/yyyy';
  LongTimeFormat := 'hh:nn:ss';
  ShortTimeFormat := 'hh:nn:ss';
  FixeDate.Text := DateToStr(now + 1/24/60);
  FixeTime.Text := TimeToStr(now + 1/24/60);
end;

procedure TMain.DemarrerClick(Sender: TObject);
begin
  MessCAR.CallMainShow := CallMainShow;
  MessCAR.CallCARDone := CallCARDone;

  // Calcul de la date  laquelle il faudra fermer l'ordinateur
  if Sender = DemarrerRebours then
  begin
    MessCAR.DateFermeture := now;
    MessCAR.DateFermeture := MessCAR.DateFermeture + CARJours.Value;
    MessCAR.DateFermeture := MessCAR.DateFermeture + CARHeures.Value / 24;
    MessCAR.DateFermeture := MessCAR.DateFermeture + CARMin.Value / 24 / 60;
    MessCAR.DateFermeture := MessCAR.DateFermeture + CARSec.Value / 24 / 60 / 60;
  end else begin
    MessCAR.DateFermeture := StrToDate(FixeDate.Text) + StrToTime(FixeTime.Text);
  end;

  // Lancement (on doit dcaler la fiche pour tre sr qu'on ne la voie pas
  // dans l'affichage du compte  rebours)
  MessCAR.TexteFormat := Config.GetTexteFormat;
  Hide;
  OldLeft := Left;
  Left := -10000;
  MessCAR.DemarrerCAR;
end;

procedure TMain.ConfigurationClick(Sender: TObject);
begin
  Config.Show;
end;

end.
